classification
Title: class property fset not working
Type: Stage:
Components: Documentation Versions:
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: georg.brandl Nosy List: georg.brandl, georg.brandl, master_jaf, mwh, rhettinger, terry.reedy
Priority: normal Keywords:

Created on 2005-05-23 22:02 by master_jaf, last changed 2007-09-12 19:05 by georg.brandl. This issue is now closed.

Files
File name Uploaded Description Edit
code.py master_jaf, 2005-05-23 22:02 sample code
Messages (10)
msg25397 - (view) Author: MartinKirst (master_jaf) Date: 2005-05-23 22:02
Classes which are not instantiated from 'object',
containing properties, are not working as expected. The
GET method is working but not the SET method. Tested
with python 2.4.1 und 2.3.5.
See sample code file.
msg25398 - (view) Author: Michael Hudson (mwh) (Python committer) Date: 2005-05-24 07:58
Logged In: YES 
user_id=6656

At the very limit, this is a documentation bug.  Why did you think 
properties could be attached to old-style classes?
msg25399 - (view) Author: MartinKirst (master_jaf) Date: 2005-05-24 12:27
Logged In: YES 
user_id=1140154

After reading some more documentation I've found at Python
Tutorial "D. Glossary" more hints.
<cite>
Any class that inherits from object. This includes all
built-in types like list and dict. Only new-style classes
can use Python's newer, versatile features like __slots__,
descriptors, properties, __getattribute__(), class methods,
and static methods.
</cite>
Fine. OK, understood..
I'm tending to agree with mwh's opinion, that this is a
documentation bug, although I don't fully understand why the
GET descriptor is working but unlikly not the SET descriptor.
msg25400 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2005-05-26 16:37
Logged In: YES 
user_id=593130

For people who learned Python with old-style classes, it 
is 'obvious' that properties are a new addition that came with and 
work with new-style classes.  Can you suggest specific places in 
the docs where clarification could be made?  Or should be close 
this?

(I suspect that setting is more complicated than getting but would 
not have expected even the get method to work.)
msg25401 - (view) Author: MartinKirst (master_jaf) Date: 2005-05-26 18:59
Logged In: YES 
user_id=1140154

From my point of view (I'm just learning Python) there is only a
simple difference between old and new style classes, just the
(object) while defining a class.
For sure, we can close this. My questions were answered :-)

So my suggestions for adding info to the documentation:

"Python Tutorial": Chap. 9.3., ex.
With Python 2.2 new style classes were introduced. These new 
style classes are inherited from 'object' base class and
supporting
newer features like properties, slots etc.. It is
recommended to use
new style classes.

"Python Library Reference": Chap. 2.1 Built-in Functions, ex.
property([fget[, fset[, fdel[, doc]]]])
  [....]
New in Python 2.2. Properties only can applied to new style
classes. See also "D. Glossary" -> new style classes for more
details.
msg25402 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2005-06-04 10:27
Logged In: YES 
user_id=1188172

Attaching a patch for the Tutorial. It adds the following
sentence:

+Note that with Python 2.2, a new kind of classes was
introduced:
+A class deriving from \class{object} is called a
\emph{new-style class}.
+The differences to classic classes are mostly internal, but
there are
+some features (like properties and static methods) that are
only
+available for new-style classes.
+
msg25403 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2005-08-21 11:35
Logged In: YES 
user_id=80475

Stay close to the definition in the tutorial's glossary:

"""
new-style class 
Any class that inherits from object. This includes all
built-in types like list and dict. Only new-style classes
can use Python's newer, versatile features like __slots__,
descriptors, properties, __getattribute__(), class methods,
and static methods. 
"""

Also, the 2.2 comment should be in standard form markup: 
\versionadded{}

"classes" ==> "class"

Overall, -0 on the update.  Ideally, the tutorial should be
kept free of the more advanced concepts like properties,
static methods, descriptors, and whatnot.  
msg25404 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2005-08-21 14:17
Logged In: YES 
user_id=1188172

What am I to do? Correct the patch and apply, or close this
as Rejected?
msg25405 - (view) Author: MartinKirst (master_jaf) Date: 2005-08-21 20:55
Logged In: YES 
user_id=1140154

I agree with rhettinger, that there is no need to put
advanced things like properties in the tutorial.

But I still think, that the property explanation in "Python
Lib. Ref."
could be a bit more precise.
IMHO it's not enough to say "Return a property attribute for
new-style classes..." because it does not prohibit
explicitly the usage in "old style classes".

Suggestion:

"Python Library Reference": Chap. 2.1 Built-in Functions, ex.
property([fget[, fset[, fdel[, doc]]]])
  [....]
New in Python 2.2. Properties only can be applied to new style
classes. See also "D. Glossary" -> new style classes for more
details.
msg55859 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2007-09-12 19:05
It says "... for new-style classes (classes that derive from object)." I
think this is clear enough.
History
Date User Action Args
2007-09-12 19:05:52georg.brandlsetstatus: open -> closed
resolution: wont fix
messages: + msg55859
2005-05-23 22:02:03master_jafcreate